//
//  utils.cpp
//
//  Created by Rafael Guerrero on 4/20/12.
//  Copyright (c) 2012 University of Texas. All rights reserved.
//
#include<vector>
using std::vector;

#include <iostream>
#include <math.h>
#include "population.h"
#include "nr3.h"

std::ostream& operator<<(std::ostream& os, const vector<double>& g){ for (int i=0;i < g.size();++i) std::cout<<g.at(i)<<" "; return os;}

std::ostream& operator<<(std::ostream& os, VecDoub & g){ for (int i=0;i < g.size();++i) std::cout<<g[i]<<" "; return os;}

double interpolate (double left, double right, double gain, double x_axis){
    double slope = (right -left)/ x_axis; 
    double val = slope *gain;
    return left + val;
}

Genotype deterministic (double w1, double w2){
	double q=0;
	double s1=w1-1.0;
	double s2=w2-1.0;
	
	if((s1<0 && s2 <0)||(s1>0 && s2 >0)  ){
		if(s1<s2) {q =1-s1/(s1+s2); }
		else {q =s1/(s1+s2); }
	}
	else if((s1<0 && s2 <0)||(s1>0 && s2 >0)  ){
		if(s1>s2) {q =1-s1/(s1+s2); }
		else {q =s1/(s1+s2); }
	}
	else if (s1 > s2 ){ q= 1.0;}
	else if (s1==s2) {q=0.5;}
	
	if(q < 0){q=0;} else if(q>1){q=1;} else if(q!=q){q=0;}
	
	Genotype out = {pow(q,2),2*q*(1-q), pow(1-q,2)}; 
	return out;
}