// SS_F.ccp
// Written by D Ayala and R Guerrero
//
// Two stepping stone alternative models, with variations on how assortative mating works.
//
#include <iostream>
using std::cout;
using std::endl;
#include <fstream>
using std::ifstream;
using std::ofstream;
#include <sstream>
using std::stringstream;

#include<math.h>

#include<vector>
using std::vector;
#include <map>
using std::map;
#include<iostream>
using std::cout;
#include <iomanip>
using std::setw;
using std::setprecision;

#include <boost/math/distributions/normal.hpp> // for normal_distribution
using boost::math::normal; 

# include "amebsa.h"
# include "nr3.h"

#include "population.h"
#include "init_commons.h"


Doub ss3_FG (VecDoub_I & vec ) {
    Doub ret; 
    Doub penalty; 
    double epsilon_one_run;
    double maxGens_one_run;
    
	SETRUNPARS
    
    int borderSH; int borderHR;
	stringstream general;
	general <<"borders.txt"; 
	ifstream fin( general.str().c_str());
	string line;
    int intemp;
	getline( fin, line);
	istringstream iss(line);
	while(iss >> intemp){
		borderSH=intemp;
	}
	getline( fin, line);
	iss.clear();
	iss.str(line);
	while(iss >> intemp){
		borderHR=intemp;
	}
	fin.close();
    
    // These next lines establish the relationship between the vec vecotr passed from the SimAnneal routine and the actual parameters in our model
    Genotype g0= {1,vec[0],vec[1]};   
	Genotype g1= {1,vec[2],vec[3]};
	Genotype g2= {1,vec[4],vec[5]};
   	vector<double> F; 
    F.resize(3);
	F.at(0)=vec[6];
	F.at(1)=vec[8];
	F.at(2)=vec[9];
  
    double sigma= vec[7];
    
    // bounds for fitness
	for(int i=0;i<6;++i){
		if(vec[i]< 0)return penalty * (1.0+fabs(vec[i]));
		if(vec[i]>10000) return penalty * (1.0+fabs(vec[i]));
	}    
    
	//  here are the bounds for F
    if(vec[6]>1||vec[6]<0) return penalty * (1.0+fabs(vec[6]));
	// bounds for migration distance
    if(vec[7]<0) return penalty * (1.0+fabs(vec[7]));
    //bounds for the F params in genos 2,3
	if(vec[8]>1||vec[8]<0) return penalty * (1.0+fabs(vec[8]));
	if(vec[9]>1||vec[9]<0) return penalty * (1.0+fabs(vec[9]));
    
	
    int nPops;
    vector<double> ss ;
    vector<double> si ;
    vector<double> ii ; 
    vector<double> distances ; 
    
    INPUTDATA	
	
    vector< Genotype > initfreq;
    vector< Genotype > W;
    initfreq.resize(nPops); 
    W.resize(nPops);
    
	for (int k=0; k< borderSH ; ++k ) {          
		W.at(k)=g0;
	}
	
	for (int k= borderSH; k< borderHR ; ++k ) {
		W.at(k)=g1;
	}
	
	for (int k=borderHR; k< nPops ; ++k ) {
		W.at(k)=g2;
	}
    
    vector<double> mig_prob; 
	INIT_MIGRATION
    INIT_FREQS
    vector <Population> cameroon;       
	FILL_POPULATIONS_AND_RUN	
	vector<Genotype> one_run= simulate(cameroon, mig_prob, W, F, epsilon_one_run, maxGens_one_run);	
    CALC_LogL
	
}

Doub ss3_fr (VecDoub_I & vec ) {
    Doub ret; 
    Doub penalty; 
    double epsilon_one_run;
    double maxGens_one_run;
    
	SETRUNPARS
    
    int borderSH; int borderHR;
	stringstream general;
	general <<"borders.txt"; 
	ifstream fin( general.str().c_str());
	string line;
    int intemp;
	getline( fin, line);
	istringstream iss(line);
	while(iss >> intemp){
		borderSH=intemp;
	}
	getline( fin, line);
	iss.clear();
	iss.str(line);
	while(iss >> intemp){
		borderHR=intemp;
	}
	fin.close();
    
    // These next lines establish the relationship between the vec vecotr passed from the SimAnneal routine and the actual parameters in our model
    Genotype g0= {1,vec[0],vec[1]};   
	Genotype g1= {1,vec[2],vec[3]};
	Genotype g2= {1,vec[4],vec[5]};
   	vector<double> F; 
   
    double sigma= vec[7];
    
    // bounds for fitness
	for(int i=0;i<6;++i){
		if(vec[i]< 0)return penalty * (1.0+fabs(vec[i]));
		if(vec[i]>10000) return penalty * (1.0+fabs(vec[i]));
	}    
    
	//  here are the bounds for F
    if(vec[6]>1||vec[6]<0) return penalty * (1.0+fabs(vec[6]));
	// bounds for migration distance
    if(vec[7]<0) return penalty * (1.0+fabs(vec[7]));
    //bounds for the F params in genos 2,3
	if(vec[8]>1||vec[8]<0) return penalty * (1.0+fabs(vec[8]));
	if(vec[9]>1||vec[9]<0) return penalty * (1.0+fabs(vec[9]));
    
	
    int nPops;
    vector<double> ss ;
    vector<double> si ;
    vector<double> ii ; 
    vector<double> distances ; 
    
    INPUTDATA	
	
    vector< Genotype > initfreq;
    vector< Genotype > W;
    initfreq.resize(nPops); 
    W.resize(nPops);
    
	
	for (int k=0; k< borderSH ; ++k ) {          
		W.at(k)=g0;
		F.at(k)=vec[6];
	}
	
	for (int k= borderSH; k< borderHR ; ++k ) {
		W.at(k)=g1;
		F.at(k)=vec[8];
	}
	
	for (int k=borderHR; k< nPops ; ++k ) {
		W.at(k)=g2;
		F.at(k)=vec[9];
	}
    
    vector<double> mig_prob; 
	INIT_MIGRATION
    INIT_FREQS
    vector <Population> cameroon;       
	FILL_POPULATIONS_AND_RUN	
	vector<Genotype> one_run= simulate(cameroon, mig_prob, W, F, epsilon_one_run, maxGens_one_run);	
    CALC_LogL
	
}
